Index: library/bdm/base/bdmbase.h
===================================================================
--- library/bdm/base/bdmbase.h (revision 487)
+++ library/bdm/base/bdmbase.h (revision 488)
@@ -25,5 +25,6 @@
 using namespace std;
 
-namespace bdm {
+namespace bdm
+{
 
 typedef std::map<string, int> RVmap;
@@ -32,14 +33,15 @@
 
 //! Structure of RV, i.e. RVs expanded into a flat list of IDs, used for debugging.
-class str {
-public:
-	//! vector id ids (non-unique!)
-	ivec ids;
-	//! vector of times
-	ivec times;
-	//!Default constructor
-	str ( ivec ids0, ivec times0 ) : ids ( ids0 ), times ( times0 ) {
-		it_assert_debug ( times0.length() == ids0.length(), "Incompatible input" );
-	};
+class str
+{
+	public:
+		//! vector id ids (non-unique!)
+		ivec ids;
+		//! vector of times
+		ivec times;
+		//!Default constructor
+		str (ivec ids0, ivec times0) : ids (ids0), times (times0) {
+			it_assert_debug (times0.length() == ids0.length(), "Incompatible input");
+		};
 };
 
@@ -82,148 +84,149 @@
 */
 
-class RV : public root {
-protected:
-	//! size of the data vector
-	int dsize;
-	//! number of individual rvs
-	int len;
-	//! Vector of unique IDs
-	ivec ids;
-	//! Vector of shifts from current time
-	ivec times;
-
-private:
-	//! auxiliary function used in constructor
-	void init ( const Array<std::string> &in_names, const ivec &in_sizes, const ivec &in_times );
-	int init ( const string &name, int size );
-public:
-	//! \name Constructors
-	//!@{
-
-	//! Full constructor
-	RV ( const Array<std::string> &in_names, const ivec &in_sizes, const ivec &in_times ) {
-		init ( in_names, in_sizes, in_times );
-	}
-
-	//! Constructor with times=0
-	RV ( const Array<std::string> &in_names, const ivec &in_sizes ) {
-		init ( in_names, in_sizes, zeros_i ( in_names.length() ) );
-	}
-
-	//! Constructor with sizes=1, times=0
-	RV ( const Array<std::string> &in_names ) {
-		init ( in_names, ones_i ( in_names.length() ), zeros_i ( in_names.length() ) );
-	}
-
-	//! Constructor of empty RV
-	RV() : dsize ( 0 ), len ( 0 ), ids ( 0 ), times ( 0 ) {}
-	//! Constructor of a single RV with given id
-	RV ( string name, int sz, int tm = 0 );
-	//!@}
-
-	//! \name Access functions
-	//!@{
-
-	//! State output, e.g. for debugging.
-	friend std::ostream &operator<< ( std::ostream &os, const RV &rv );
-
-	int _dsize() const {
-		return dsize;
-	}
-
-	//! Recount size of the corresponding data vector
-	int countsize() const;
-	ivec cumsizes() const;
-	int length() const {
-		return len;
-	}
-	int id ( int at ) const {
-		return ids ( at );
-	}
-	int size ( int at ) const {
-		return RV_SIZES ( ids ( at ) );
-	}
-	int time ( int at ) const {
-		return times ( at );
-	}
-	std::string name ( int at ) const {
-		return RV_NAMES ( ids ( at ) );
-	}
-	void set_time ( int at, int time0 ) {
-		times ( at ) = time0;
-	}
-	//!@}
-
-	//TODO why not inline and later??
-
-	//! \name Algebra on Random Variables
-	//!@{
-
-	//! Find indices of self in another rv, \return ivec of the same size as self.
-	ivec findself ( const RV &rv2 ) const;
-	//! Compare if \c rv2 is identical to this \c RV
-	bool equal ( const RV &rv2 ) const;
-	//! Add (concat) another variable to the current one, \return true if all rv2 were added, false if rv2 is in conflict
-	bool add ( const RV &rv2 );
-	//! Subtract  another variable from the current one
-	RV subt ( const RV &rv2 ) const;
-	//! Select only variables at indices ind
-	RV subselect ( const ivec &ind ) const;
-
-	//! Select only variables at indices ind
-	RV operator() ( const ivec &ind ) const {
-		return subselect ( ind );
-	}
-
-	//! Select from data vector starting at di1 to di2
-	RV operator() ( int di1, int di2 ) const;
-
-	//! Shift \c time by delta.
-	void t ( int delta );
-	//!@}
-
-	//!\name Relation to vectors
-	//!@{
-
-	//! generate \c str from rv, by expanding sizes TODO to_string..
-	str tostr() const;
-	//! when this rv is a part of bigger rv, this function returns indices of self in the data vector of the bigger crv.
-	//! Then, data can be copied via: data_of_this = cdata(ind);
-	ivec dataind ( const RV &crv ) const;
-	//! generate mutual indices when copying data between self and crv.
-	//! Data are copied via: data_of_this(selfi) = data_of_rv2(rv2i)
-	void dataind ( const RV &rv2, ivec &selfi, ivec &rv2i ) const;
-	//! Minimum time-offset
-	int mint() const {
-		return min ( times );
-	}
-	//!@}
-
-	// TODO aktualizovat dle soucasneho UI
-	/*! \brief UI for class RV (description of data vectors)
-
-	\code
-	rv = {
-	  type = "rv"; //identifier of the description
-	  // UNIQUE IDENTIFIER same names = same variable
-	  names = ["a", "b", "c", ...];   // which will be used e.g. in loggers
-
-	  //optional arguments
-	  sizes = [1, 2, 3, ...];         // (optional) default = ones()
-	  times = [-1, -2, 0, ...];       // time shifts with respect to current time (optional) default = zeros()
-	}
-	\endcode
-	*/
-	void from_setting ( const Setting &set );
-
-	// TODO dodelat void to_setting( Setting &set ) const;
-
-	//! Invalidate all named RVs. Use before initializing any RV instances, with care...
-	static void clear_all();
-};
-UIREGISTER ( RV );
+class RV : public root
+{
+	protected:
+		//! size of the data vector
+		int dsize;
+		//! number of individual rvs
+		int len;
+		//! Vector of unique IDs
+		ivec ids;
+		//! Vector of shifts from current time
+		ivec times;
+
+	private:
+		//! auxiliary function used in constructor
+		void init (const Array<std::string> &in_names, const ivec &in_sizes, const ivec &in_times);
+		int init (const string &name, int size);
+	public:
+		//! \name Constructors
+		//!@{
+
+		//! Full constructor
+		RV (const Array<std::string> &in_names, const ivec &in_sizes, const ivec &in_times) {
+			init (in_names, in_sizes, in_times);
+		}
+
+		//! Constructor with times=0
+		RV (const Array<std::string> &in_names, const ivec &in_sizes) {
+			init (in_names, in_sizes, zeros_i (in_names.length()));
+		}
+
+		//! Constructor with sizes=1, times=0
+		RV (const Array<std::string> &in_names) {
+			init (in_names, ones_i (in_names.length()), zeros_i (in_names.length()));
+		}
+
+		//! Constructor of empty RV
+		RV() : dsize (0), len (0), ids (0), times (0) {}
+		//! Constructor of a single RV with given id
+		RV (string name, int sz, int tm = 0);
+		//!@}
+
+		//! \name Access functions
+		//!@{
+
+		//! State output, e.g. for debugging.
+		friend std::ostream &operator<< (std::ostream &os, const RV &rv);
+
+		int _dsize() const {
+			return dsize;
+		}
+
+		//! Recount size of the corresponding data vector
+		int countsize() const;
+		ivec cumsizes() const;
+		int length() const {
+			return len;
+		}
+		int id (int at) const {
+			return ids (at);
+		}
+		int size (int at) const {
+			return RV_SIZES (ids (at));
+		}
+		int time (int at) const {
+			return times (at);
+		}
+		std::string name (int at) const {
+			return RV_NAMES (ids (at));
+		}
+		void set_time (int at, int time0) {
+			times (at) = time0;
+		}
+		//!@}
+
+		//TODO why not inline and later??
+
+		//! \name Algebra on Random Variables
+		//!@{
+
+		//! Find indices of self in another rv, \return ivec of the same size as self.
+		ivec findself (const RV &rv2) const;
+		//! Compare if \c rv2 is identical to this \c RV
+		bool equal (const RV &rv2) const;
+		//! Add (concat) another variable to the current one, \return true if all rv2 were added, false if rv2 is in conflict
+		bool add (const RV &rv2);
+		//! Subtract  another variable from the current one
+		RV subt (const RV &rv2) const;
+		//! Select only variables at indices ind
+		RV subselect (const ivec &ind) const;
+
+		//! Select only variables at indices ind
+		RV operator() (const ivec &ind) const {
+			return subselect (ind);
+		}
+
+		//! Select from data vector starting at di1 to di2
+		RV operator() (int di1, int di2) const;
+
+		//! Shift \c time by delta.
+		void t (int delta);
+		//!@}
+
+		//!\name Relation to vectors
+		//!@{
+
+		//! generate \c str from rv, by expanding sizes TODO to_string..
+		str tostr() const;
+		//! when this rv is a part of bigger rv, this function returns indices of self in the data vector of the bigger crv.
+		//! Then, data can be copied via: data_of_this = cdata(ind);
+		ivec dataind (const RV &crv) const;
+		//! generate mutual indices when copying data between self and crv.
+		//! Data are copied via: data_of_this(selfi) = data_of_rv2(rv2i)
+		void dataind (const RV &rv2, ivec &selfi, ivec &rv2i) const;
+		//! Minimum time-offset
+		int mint() const {
+			return min (times);
+		}
+		//!@}
+
+		// TODO aktualizovat dle soucasneho UI
+		/*! \brief UI for class RV (description of data vectors)
+
+		\code
+		rv = {
+		  type = "rv"; //identifier of the description
+		  // UNIQUE IDENTIFIER same names = same variable
+		  names = ["a", "b", "c", ...];   // which will be used e.g. in loggers
+
+		  //optional arguments
+		  sizes = [1, 2, 3, ...];         // (optional) default = ones()
+		  times = [-1, -2, 0, ...];       // time shifts with respect to current time (optional) default = zeros()
+		}
+		\endcode
+		*/
+		void from_setting (const Setting &set);
+
+		// TODO dodelat void to_setting( Setting &set ) const;
+
+		//! Invalidate all named RVs. Use before initializing any RV instances, with care...
+		static void clear_all();
+};
+UIREGISTER (RV);
 
 //! Concat two random variables
-RV concat ( const RV &rv1, const RV &rv2 );
+RV concat (const RV &rv1, const RV &rv2);
 
 //!Default empty RV that can be used as default argument
@@ -232,23 +235,24 @@
 //! Class representing function \f$f(x)\f$ of variable \f$x\f$ represented by \c rv
 
-class fnc : public root {
-protected:
-	//! Length of the output vector
-	int dimy;
-public:
-	//!default constructor
-	fnc() {};
-	//! function evaluates numerical value of \f$f(x)\f$ at \f$x=\f$ \c cond
-	virtual vec eval ( const vec &cond ) {
-		return vec ( 0 );
-	};
-
-	//! function substitutes given value into an appropriate position
-	virtual void condition ( const vec &val ) {};
-
-	//! access function
-	int dimension() const {
-		return dimy;
-	}
+class fnc : public root
+{
+	protected:
+		//! Length of the output vector
+		int dimy;
+	public:
+		//!default constructor
+		fnc() {};
+		//! function evaluates numerical value of \f$f(x)\f$ at \f$x=\f$ \c cond
+		virtual vec eval (const vec &cond) {
+			return vec (0);
+		};
+
+		//! function substitutes given value into an appropriate position
+		virtual void condition (const vec &val) {};
+
+		//! access function
+		int dimension() const {
+			return dimy;
+		}
 };
 
@@ -257,140 +261,141 @@
 //! Probability density function with numerical statistics, e.g. posterior density.
 
-class epdf : public root {
-protected:
-	//! dimension of the random variable
-	int dim;
-	//! Description of the random variable
-	RV rv;
-
-public:
-	/*! \name Constructors
-	 Construction of each epdf should support two types of constructors:
-	\li empty constructor,
-	\li copy constructor,
-
-	The following constructors should be supported for convenience:
-	\li constructor followed by calling \c set_parameters()
-	\li constructor accepting random variables calling \c set_rv()
-
-	 All internal data structures are constructed as empty. Their values (including sizes) will be set by method \c set_parameters(). This way references can be initialized in constructors.
-	@{*/
-	epdf() : dim ( 0 ), rv() {};
-	epdf ( const epdf &e ) : dim ( e.dim ), rv ( e.rv ) {};
-	epdf ( const RV &rv0 ) : dim ( rv0._dsize() ) {
-		set_rv ( rv0 );
-	};
-	void set_parameters ( int dim0 ) {
-		dim = dim0;
-	}
-	//!@}
-
-	//! \name Matematical Operations
-	//!@{
-
-	//! Returns a sample, \f$ x \f$ from density \f$ f_x()\f$
-	virtual vec sample() const {
-		it_error ( "not implemneted" );
-		return vec ( 0 );
-	};
-	//! Returns N samples, \f$ [x_1 , x_2 , \ldots \ \f$  from density \f$ f_x(rv)\f$
-	virtual mat sample_m ( int N ) const;
-	//! Compute log-probability of argument \c val
-	//! In case the argument is out of suport return -Infinity
-	virtual double evallog ( const vec &val ) const {
-		it_error ( "not implemneted" );
-		return 0.0;
-	};
-	//! Compute log-probability of multiple values argument \c val
-	virtual vec evallog_m ( const mat &Val ) const {
-		vec x ( Val.cols() );
-		for ( int i = 0; i < Val.cols(); i++ ) {
-			x ( i ) = evallog ( Val.get_col ( i ) ) ;
-		}
-		return x;
-	}
-	//! Compute log-probability of multiple values argument \c val
-	virtual vec evallog_m ( const Array<vec> &Avec ) const {
-		vec x ( Avec.size() );
-		for ( int i = 0; i < Avec.size(); i++ ) {
-			x ( i ) = evallog ( Avec ( i ) ) ;
-		}
-		return x;
-	}
-	//! Return conditional density on the given RV, the remaining rvs will be in conditioning
-	virtual mpdf* condition ( const RV &rv ) const  {
-		it_warning ( "Not implemented" );
-		return NULL;
-	}
-
-	//! Return marginal density on the given RV, the remainig rvs are intergrated out
-	virtual epdf* marginal ( const RV &rv ) const {
-		it_warning ( "Not implemented" );
-		return NULL;
-	}
-
-	//! return expected value
-	virtual vec mean() const {
-		it_error ( "not implemneted" );
-		return vec ( 0 );
-	};
-
-	//! return expected variance (not covariance!)
-	virtual vec variance() const {
-		it_error ( "not implemneted" );
-		return vec ( 0 );
-	};
-	//! Lower and upper bounds of \c percentage % quantile, returns mean-2*sigma as default
-	virtual void qbounds ( vec &lb, vec &ub, double percentage = 0.95 ) const {
-		vec mea = mean();
-		vec std = sqrt ( variance() );
-		lb = mea - 2 * std;
-		ub = mea + 2 * std;
-	};
-	//!@}
-
-	//! \name Connection to other classes
-	//! Description of the random quantity via attribute \c rv is optional.
-	//! For operations such as sampling \c rv does not need to be set. However, for \c marginalization
-	//! and \c conditioning \c rv has to be set. NB:
-	//! @{
-
-	//!Name its rv
-	void set_rv ( const RV &rv0 ) {
-		rv = rv0;
-	}   //it_assert_debug(isnamed(),""); };
-	//! True if rv is assigned
-	bool isnamed() const {
-		bool b = ( dim == rv._dsize() );
-		return b;
-	}
-	//! Return name (fails when isnamed is false)
-	const RV& _rv() const {
-		it_assert_debug ( isnamed(), "" );
-		return rv;
-	}
-	//!@}
-
-	//! \name Access to attributes
-	//! @{
-
-	//! Size of the random variable
-	int dimension() const {
-		return dim;
-	}
-	//! Load from structure with elements:
-	//!  \code
-	//! { rv = {class="RV", names=(...),}; // RV describing meaning of random variable
-	//!   // elements of offsprings
-	//! }
-	//! \endcode
-	//!@}
-	void from_setting ( const Setting &set ) {
-		RV* r = UI::build<RV> ( set, "rv" );
-		if ( r ) {
-			set_rv ( *r );
-			delete r;
-		}
-	}
+class epdf : public root
+{
+	protected:
+		//! dimension of the random variable
+		int dim;
+		//! Description of the random variable
+		RV rv;
+
+	public:
+		/*! \name Constructors
+		 Construction of each epdf should support two types of constructors:
+		\li empty constructor,
+		\li copy constructor,
+
+		The following constructors should be supported for convenience:
+		\li constructor followed by calling \c set_parameters()
+		\li constructor accepting random variables calling \c set_rv()
+
+		 All internal data structures are constructed as empty. Their values (including sizes) will be set by method \c set_parameters(). This way references can be initialized in constructors.
+		@{*/
+		epdf() : dim (0), rv() {};
+		epdf (const epdf &e) : dim (e.dim), rv (e.rv) {};
+		epdf (const RV &rv0) : dim (rv0._dsize()) {
+			set_rv (rv0);
+		};
+		void set_parameters (int dim0) {
+			dim = dim0;
+		}
+		//!@}
+
+		//! \name Matematical Operations
+		//!@{
+
+		//! Returns a sample, \f$ x \f$ from density \f$ f_x()\f$
+		virtual vec sample() const {
+			it_error ("not implemneted");
+			return vec (0);
+		};
+		//! Returns N samples, \f$ [x_1 , x_2 , \ldots \ \f$  from density \f$ f_x(rv)\f$
+		virtual mat sample_m (int N) const;
+		//! Compute log-probability of argument \c val
+		//! In case the argument is out of suport return -Infinity
+		virtual double evallog (const vec &val) const {
+			it_error ("not implemneted");
+			return 0.0;
+		};
+		//! Compute log-probability of multiple values argument \c val
+		virtual vec evallog_m (const mat &Val) const {
+			vec x (Val.cols());
+			for (int i = 0; i < Val.cols(); i++) {
+				x (i) = evallog (Val.get_col (i)) ;
+			}
+			return x;
+		}
+		//! Compute log-probability of multiple values argument \c val
+		virtual vec evallog_m (const Array<vec> &Avec) const {
+			vec x (Avec.size());
+			for (int i = 0; i < Avec.size(); i++) {
+				x (i) = evallog (Avec (i)) ;
+			}
+			return x;
+		}
+		//! Return conditional density on the given RV, the remaining rvs will be in conditioning
+		virtual mpdf* condition (const RV &rv) const  {
+			it_warning ("Not implemented");
+			return NULL;
+		}
+
+		//! Return marginal density on the given RV, the remainig rvs are intergrated out
+		virtual epdf* marginal (const RV &rv) const {
+			it_warning ("Not implemented");
+			return NULL;
+		}
+
+		//! return expected value
+		virtual vec mean() const {
+			it_error ("not implemneted");
+			return vec (0);
+		};
+
+		//! return expected variance (not covariance!)
+		virtual vec variance() const {
+			it_error ("not implemneted");
+			return vec (0);
+		};
+		//! Lower and upper bounds of \c percentage % quantile, returns mean-2*sigma as default
+		virtual void qbounds (vec &lb, vec &ub, double percentage = 0.95) const {
+			vec mea = mean();
+			vec std = sqrt (variance());
+			lb = mea - 2 * std;
+			ub = mea + 2 * std;
+		};
+		//!@}
+
+		//! \name Connection to other classes
+		//! Description of the random quantity via attribute \c rv is optional.
+		//! For operations such as sampling \c rv does not need to be set. However, for \c marginalization
+		//! and \c conditioning \c rv has to be set. NB:
+		//! @{
+
+		//!Name its rv
+		void set_rv (const RV &rv0) {
+			rv = rv0;
+		}   //it_assert_debug(isnamed(),""); };
+		//! True if rv is assigned
+		bool isnamed() const {
+			bool b = (dim == rv._dsize());
+			return b;
+		}
+		//! Return name (fails when isnamed is false)
+		const RV& _rv() const {
+			it_assert_debug (isnamed(), "");
+			return rv;
+		}
+		//!@}
+
+		//! \name Access to attributes
+		//! @{
+
+		//! Size of the random variable
+		int dimension() const {
+			return dim;
+		}
+		//! Load from structure with elements:
+		//!  \code
+		//! { rv = {class="RV", names=(...),}; // RV describing meaning of random variable
+		//!   // elements of offsprings
+		//! }
+		//! \endcode
+		//!@}
+		void from_setting (const Setting &set) {
+			RV* r = UI::build<RV> (set, "rv");
+			if (r) {
+				set_rv (*r);
+				delete r;
+			}
+		}
 
 };
@@ -399,115 +404,117 @@
 //! Conditional probability density, e.g. modeling some dependencies.
 //TODO Samplecond can be generalized
-class mpdf : public root {
-protected:
-	//!dimension of the condition
-	int dimc;
-	//! random variable in condition
-	RV rvc;
-private:
-	//! internal epdf, used only as cache to avoid virtual calls of \c _rv() and \c _dimension()
-	epdf* ep;
-	
-protected:
-	void set_ep(epdf &iepdf) {
-		ep = &iepdf;
-	}
-
-public:
-	//! \name Constructors
-	//! @{
-
-	mpdf() : dimc ( 0 ), rvc(), ep(NULL) { }
-
-	mpdf ( const mpdf &m ) : dimc ( m.dimc ), rvc ( m.rvc ), ep ( m.ep ) { }
-	//!@}
-
-	//! \name Matematical operations
-	//!@{
-
-	//! Returns a sample from the density conditioned on \c cond, \f$x \sim epdf(rv|cond)\f$. \param cond is numeric value of \c rv
-	virtual vec samplecond ( const vec &cond ){it_error("Not implemented");return vec(0);};
-
-	//! Returns \param N samples from the density conditioned on \c cond, \f$x \sim epdf(rv|cond)\f$. \param cond is numeric value of \c rv
-	virtual mat samplecond_m ( const vec &cond, int N ){it_error("Not implemented");return mat();}
-
-
-	//! Shortcut for conditioning and evaluation of the internal epdf. In some cases,  this operation can be implemented efficiently.
-	virtual double evallogcond ( const vec &dt, const vec &cond ){it_error("Not implemented");return 0.0;}
-
-	//! Matrix version of evallogcond
-	virtual vec evallogcond_m ( const mat &Dt, const vec &cond ){it_error("Not implemented");return vec(0);}
-
-	//! Array<vec> version of evallogcond
-	virtual vec evallogcond_m ( const Array<vec> &Dt, const vec &cond ){it_error("Not implemented");return vec(0);}
-
-	//! \name Access to attributes
-	//! @{
-
-	RV _rv() {
-		return ep->_rv();
-	}
-	RV _rvc() {
-		it_assert_debug ( isnamed(), "" );
-		return rvc;
-	}
-	int dimension() {
-		return ep->dimension();
-	}
-	int dimensionc() {
-		return dimc;
-	}
-
-	//! Load from structure with elements:
-	//!  \code
-	//! { class = "mpdf_offspring",
-	//!   rv = {class="RV", names=(...),}; // RV describing meaning of random variable
-	//!   rvc= {class="RV", names=(...),}; // RV describing meaning of random variable in condition
-	//!   // elements of offsprings
-	//! }
-	//! \endcode
-	//!@}
-	void from_setting ( const Setting &set );
-	//!@}
-
-	//! \name Connection to other objects
-	//!@{
-	void set_rvc ( const RV &rvc0 ) {
-		rvc = rvc0;
-	}
-	void set_rv ( const RV &rv0 ) {
-		ep->set_rv ( rv0 );
-	}
-	bool isnamed() {
-		return ( ep->isnamed() ) && ( dimc == rvc._dsize() );
-	}
-	//!@}
+class mpdf : public root
+{
+	protected:
+		//!dimension of the condition
+		int dimc;
+		//! random variable in condition
+		RV rvc;
+	private:
+		//! internal epdf, used only as cache to avoid virtual calls of \c _rv() and \c _dimension()
+		epdf* ep;
+
+	protected:
+		void set_ep (epdf &iepdf) {
+			ep = &iepdf;
+		}
+
+	public:
+		//! \name Constructors
+		//! @{
+
+		mpdf() : dimc (0), rvc(), ep (NULL) { }
+
+		mpdf (const mpdf &m) : dimc (m.dimc), rvc (m.rvc), ep (m.ep) { }
+		//!@}
+
+		//! \name Matematical operations
+		//!@{
+
+		//! Returns a sample from the density conditioned on \c cond, \f$x \sim epdf(rv|cond)\f$. \param cond is numeric value of \c rv
+		virtual vec samplecond (const vec &cond) {it_error ("Not implemented");return vec (0);};
+
+		//! Returns \param N samples from the density conditioned on \c cond, \f$x \sim epdf(rv|cond)\f$. \param cond is numeric value of \c rv
+		virtual mat samplecond_m (const vec &cond, int N) {it_error ("Not implemented");return mat();}
+
+
+		//! Shortcut for conditioning and evaluation of the internal epdf. In some cases,  this operation can be implemented efficiently.
+		virtual double evallogcond (const vec &dt, const vec &cond) {it_error ("Not implemented");return 0.0;}
+
+		//! Matrix version of evallogcond
+		virtual vec evallogcond_m (const mat &Dt, const vec &cond) {it_error ("Not implemented");return vec (0);}
+
+		//! Array<vec> version of evallogcond
+		virtual vec evallogcond_m (const Array<vec> &Dt, const vec &cond) {it_error ("Not implemented");return vec (0);}
+
+		//! \name Access to attributes
+		//! @{
+
+		RV _rv() {
+			return ep->_rv();
+		}
+		RV _rvc() {
+			it_assert_debug (isnamed(), "");
+			return rvc;
+		}
+		int dimension() {
+			return ep->dimension();
+		}
+		int dimensionc() {
+			return dimc;
+		}
+
+		//! Load from structure with elements:
+		//!  \code
+		//! { class = "mpdf_offspring",
+		//!   rv = {class="RV", names=(...),}; // RV describing meaning of random variable
+		//!   rvc= {class="RV", names=(...),}; // RV describing meaning of random variable in condition
+		//!   // elements of offsprings
+		//! }
+		//! \endcode
+		//!@}
+		void from_setting (const Setting &set);
+		//!@}
+
+		//! \name Connection to other objects
+		//!@{
+		void set_rvc (const RV &rvc0) {
+			rvc = rvc0;
+		}
+		void set_rv (const RV &rv0) {
+			ep->set_rv (rv0);
+		}
+		bool isnamed() {
+			return (ep->isnamed()) && (dimc == rvc._dsize());
+		}
+		//!@}
 };
 
 template <class EPDF>
-class mpdf_internal: public mpdf{
+class mpdf_internal: public mpdf
+{
 	protected :
 		EPDF iepdf;
 	public:
 		//! constructor
-		mpdf_internal(): mpdf(),iepdf(){set_ep(iepdf);}
+		mpdf_internal() : mpdf(), iepdf() {set_ep (iepdf);}
 		//! Update \c iepdf so that it represents this mpdf conditioned on \c rvc = cond
 		//! This function provides convenient reimplementation in offsprings
-			virtual void condition ( const vec &cond ) {
-				it_error ( "Not implemented" );
-			};
+		virtual void condition (const vec &cond) {
+			it_error ("Not implemented");
+		};
 		//!access function to iepdf
-		EPDF& e(){return iepdf;}
-			
+		EPDF& e() {return iepdf;}
+
 		//! Reimplements samplecond using \c condition()
-		vec samplecond ( const vec &cond );
+		vec samplecond (const vec &cond);
 		//! Reimplements evallogcond using \c condition()
-		double evallogcond ( const vec &val, const vec &cond );
-		//! Efficient version of evallogcond for matrices 
-		virtual vec evallogcond_m ( const mat &Dt, const vec &cond );
+		double evallogcond (const vec &val, const vec &cond);
+		//! Efficient version of evallogcond for matrices
+		virtual vec evallogcond_m (const mat &Dt, const vec &cond);
 		//! Efficient version of evallogcond for Array<vec>
-		virtual vec evallogcond_m ( const Array<vec> &Dt, const vec &cond );
-		//! Efficient version of samplecond 
-		virtual mat samplecond_m ( const vec &cond, int N );
+		virtual vec evallogcond_m (const Array<vec> &Dt, const vec &cond);
+		//! Efficient version of samplecond
+		virtual mat samplecond_m (const vec &cond, int N);
 };
 
@@ -537,119 +544,122 @@
 
 */
-class datalink {
-protected:
-	//! Remember how long val should be
-	int downsize;
-
-	//! Remember how long val of "Up" should be
-	int upsize;
-
-	//! val-to-val link, indices of the upper val
-	ivec v2v_up;
-
-public:
-	//! Constructor
-	datalink() : downsize ( 0 ), upsize ( 0 ) { }
-	datalink ( const RV &rv, const RV &rv_up ) {
-		set_connection ( rv, rv_up );
-	}
-
-	//! set connection, rv must be fully present in rv_up
-	void set_connection ( const RV &rv, const RV &rv_up ) {
-		downsize = rv._dsize();
-		upsize = rv_up._dsize();
-		v2v_up = rv.dataind ( rv_up );
-
-		it_assert_debug ( v2v_up.length() == downsize, "rv is not fully in rv_up" );
-	}
-
-	//! set connection using indices
-	void set_connection ( int ds, int us, const ivec &upind ) {
-		downsize = ds;
-		upsize = us;
-		v2v_up = upind;
-
-		it_assert_debug ( v2v_up.length() == downsize, "rv is not fully in rv_up" );
-	}
-
-	//! Get val for myself from val of "Up"
-	vec pushdown ( const vec &val_up ) {
-		it_assert_debug ( upsize == val_up.length(), "Wrong val_up" );
-		return get_vec ( val_up, v2v_up );
-	}
-
-	//! Fill val of "Up" by my pieces
-	void pushup ( vec &val_up, const vec &val ) {
-		it_assert_debug ( downsize == val.length(), "Wrong val" );
-		it_assert_debug ( upsize == val_up.length(), "Wrong val_up" );
-		set_subvector ( val_up, v2v_up, val );
-	}
+class datalink
+{
+	protected:
+		//! Remember how long val should be
+		int downsize;
+
+		//! Remember how long val of "Up" should be
+		int upsize;
+
+		//! val-to-val link, indices of the upper val
+		ivec v2v_up;
+
+	public:
+		//! Constructor
+		datalink() : downsize (0), upsize (0) { }
+		datalink (const RV &rv, const RV &rv_up) {
+			set_connection (rv, rv_up);
+		}
+
+		//! set connection, rv must be fully present in rv_up
+		void set_connection (const RV &rv, const RV &rv_up) {
+			downsize = rv._dsize();
+			upsize = rv_up._dsize();
+			v2v_up = rv.dataind (rv_up);
+
+			it_assert_debug (v2v_up.length() == downsize, "rv is not fully in rv_up");
+		}
+
+		//! set connection using indices
+		void set_connection (int ds, int us, const ivec &upind) {
+			downsize = ds;
+			upsize = us;
+			v2v_up = upind;
+
+			it_assert_debug (v2v_up.length() == downsize, "rv is not fully in rv_up");
+		}
+
+		//! Get val for myself from val of "Up"
+		vec pushdown (const vec &val_up) {
+			it_assert_debug (upsize == val_up.length(), "Wrong val_up");
+			return get_vec (val_up, v2v_up);
+		}
+
+		//! Fill val of "Up" by my pieces
+		void pushup (vec &val_up, const vec &val) {
+			it_assert_debug (downsize == val.length(), "Wrong val");
+			it_assert_debug (upsize == val_up.length(), "Wrong val_up");
+			set_subvector (val_up, v2v_up, val);
+		}
 };
 
 //! Data link with a condition.
-class datalink_m2e: public datalink {
-protected:
-	//! Remember how long cond should be
-	int condsize;
-
-	//!upper_val-to-local_cond link, indices of the upper val
-	ivec v2c_up;
-
-	//!upper_val-to-local_cond link, indices of the local cond
-	ivec v2c_lo;
-
-public:
-	//! Constructor
-	datalink_m2e() : condsize ( 0 ) { }
-
-	void set_connection ( const RV &rv, const RV &rvc, const RV &rv_up ) {
-		datalink::set_connection ( rv, rv_up );
-		condsize = rvc._dsize();
-		//establish v2c connection
-		rvc.dataind ( rv_up, v2c_lo, v2c_up );
-	}
-
-	//!Construct condition
-	vec get_cond ( const vec &val_up ) {
-		vec tmp ( condsize );
-		set_subvector ( tmp, v2c_lo, val_up ( v2c_up ) );
-		return tmp;
-	}
-
-	void pushup_cond ( vec &val_up, const vec &val, const vec &cond ) {
-		it_assert_debug ( downsize == val.length(), "Wrong val" );
-		it_assert_debug ( upsize == val_up.length(), "Wrong val_up" );
-		set_subvector ( val_up, v2v_up, val );
-		set_subvector ( val_up, v2c_up, cond );
-	}
+class datalink_m2e: public datalink
+{
+	protected:
+		//! Remember how long cond should be
+		int condsize;
+
+		//!upper_val-to-local_cond link, indices of the upper val
+		ivec v2c_up;
+
+		//!upper_val-to-local_cond link, indices of the local cond
+		ivec v2c_lo;
+
+	public:
+		//! Constructor
+		datalink_m2e() : condsize (0) { }
+
+		void set_connection (const RV &rv, const RV &rvc, const RV &rv_up) {
+			datalink::set_connection (rv, rv_up);
+			condsize = rvc._dsize();
+			//establish v2c connection
+			rvc.dataind (rv_up, v2c_lo, v2c_up);
+		}
+
+		//!Construct condition
+		vec get_cond (const vec &val_up) {
+			vec tmp (condsize);
+			set_subvector (tmp, v2c_lo, val_up (v2c_up));
+			return tmp;
+		}
+
+		void pushup_cond (vec &val_up, const vec &val, const vec &cond) {
+			it_assert_debug (downsize == val.length(), "Wrong val");
+			it_assert_debug (upsize == val_up.length(), "Wrong val_up");
+			set_subvector (val_up, v2v_up, val);
+			set_subvector (val_up, v2c_up, cond);
+		}
 };
 
 //!DataLink is a connection between mpdf and its superordinate (Up)
 //! This class links
-class datalink_m2m: public datalink_m2e {
-protected:
-	//!cond-to-cond link, indices of the upper cond
-	ivec c2c_up;
-	//!cond-to-cond link, indices of the local cond
-	ivec c2c_lo;
-
-public:
-	//! Constructor
-	datalink_m2m() {};
-	void set_connection ( const RV &rv, const RV &rvc, const RV &rv_up, const RV &rvc_up ) {
-		datalink_m2e::set_connection ( rv, rvc, rv_up );
-		//establish c2c connection
-		rvc.dataind ( rvc_up, c2c_lo, c2c_up );
-		it_assert_debug ( c2c_lo.length() + v2c_lo.length() == condsize, "cond is not fully given" );
-	}
-
-	//! Get cond for myself from val and cond of "Up"
-	vec get_cond ( const vec &val_up, const vec &cond_up ) {
-		vec tmp ( condsize );
-		set_subvector ( tmp, v2c_lo, val_up ( v2c_up ) );
-		set_subvector ( tmp, c2c_lo, cond_up ( c2c_up ) );
-		return tmp;
-	}
-	//! Fill
+class datalink_m2m: public datalink_m2e
+{
+	protected:
+		//!cond-to-cond link, indices of the upper cond
+		ivec c2c_up;
+		//!cond-to-cond link, indices of the local cond
+		ivec c2c_lo;
+
+	public:
+		//! Constructor
+		datalink_m2m() {};
+		void set_connection (const RV &rv, const RV &rvc, const RV &rv_up, const RV &rvc_up) {
+			datalink_m2e::set_connection (rv, rvc, rv_up);
+			//establish c2c connection
+			rvc.dataind (rvc_up, c2c_lo, c2c_up);
+			it_assert_debug (c2c_lo.length() + v2c_lo.length() == condsize, "cond is not fully given");
+		}
+
+		//! Get cond for myself from val and cond of "Up"
+		vec get_cond (const vec &val_up, const vec &cond_up) {
+			vec tmp (condsize);
+			set_subvector (tmp, v2c_lo, val_up (v2c_up));
+			set_subvector (tmp, c2c_lo, cond_up (c2c_up));
+			return tmp;
+		}
+		//! Fill
 
 };
